// Copyright (c) 2014 The Foundry Visionmongers Ltd.  All Rights Reserved.
#ifndef NUKE_MOVREADER_FORMAT_H
#define NUKE_MOVREADER_FORMAT_H


#include "DDImage/Reader.h"

const char* const kDecoderLabels[3] =
{
  "mov64",
  "mov32",
  0,
};

enum {
  kDecoderMov64,
  kDecoderMov32
};


///////////////////////////////////////////////////////////////////////////////////////////////
class mov64ReaderFormat;
class mov32ReaderFormat;

// Proxy class for mov32 and mov64 reader formats
class movReaderFormat : public DD::Image::ReaderFormat
{
public:
  movReaderFormat(DD::Image::Read* iop);
  virtual ~movReaderFormat();

  void               selectReaderFormat();
  int                getDecoder() const { return _decoder; }
  mov64ReaderFormat* getMov64ReaderFormat() { return _mov64ReaderFormat; }
  mov32ReaderFormat* getMov32ReaderFormat() { return _mov32ReaderFormat; }
  void               detectDecoderToUse(const char* filename);

  // ReaderFormat overrides
  void knobs(DD::Image::Knob_Callback c);
  int  knob_changed(DD::Image::Knob* knob);
  void append(DD::Image::Hash& hash);
  void initDynamicKnobs();

private:
  DD::Image::Read* _iop;
  mov64ReaderFormat* _mov64ReaderFormat;
  mov32ReaderFormat* _mov32ReaderFormat;

  int _decoder;
  static int _mov64ReaderEnabled;
};

#endif
